# Research & Development Oportunities

This page describes some topics in Smart Cities that could be researched
and hence return technical contributions to the platform.


# Data Processing

* Development and evaluation of architectures for processing Big Data
* Historical data aggregation and compression
* Real time processing
* Big Data as a Service

# Machine Learning

* Development of machine learning models for cities
* Support machine learning as a service into InterSCity architecture
* Event detection based on machine learning algorithms

# Data Visualization

* CityDashboard - visualization service to support InterSCity's admins.
Currently, we already have the Resource Viewer service which is based on EmberJS
to present data related to city resources. However, several visualization
techiniques can be tested and evaluated against Smart City requirements to
present both historical, real-time, geolocalized, and static data.

# Simulation

* Provide simulation services integrated with the Platform, such as:
** Integrate the [SCSimulator](https://github.com/ezambomsantana/smart-city-simulator)
** Offer services to enable applications to setup simulations in order to operate the platform over simulated data, i.e:
The simulator provide simulated observations from city which can be consumed by client applications through Data Collector API.
In the meantime, applications could send actuation commands that would change the execution of the simulation

# Real Applications

* Several Smart City applications could be developed on the top of InterSCity.
Some examples can be found in [here](../applications/applications.md)
Idealy, these applications should use real data and resolve real
problems faced by cities. However, it could also relies on simulated data for
proof of concept.

# Microservices Architecture

* How microservices architecture impacts on Smart City solutions?
* Apply [microservices design patterns](http://microservices.io/) in
the InterSCity platform, such as API Gateway and Service Discovery, and 
evaluate their impact in terms of scalalbility, development support, 
and evolvability.
* Create a Microservice Chassi that comprise the basic structure to register
on Kong, connect with RabbitMQ, provides a health check endpoint to enable 
the rapid development of new microservices

# Interoperability

* Support other API standards to integrate and replicate smart city applications.
For instance, support the APIs proposed by [CitySDK project](https://www.citysdk.eu/)

# GIS

* Introduce a specific microservice to provide Geolocation-based services. I.E.: [GeoServer](http://geoserver.org/)
